      SUBROUTINE QS16R(RINT1,RINT2,A,B,F,P,Q,R,E,K,L1,L2,IERR)
         INTEGER IERR,K,L1,L2
         REAL A,B,E,P,Q,R,RINT1,RINT2
         EXTERNAL UTQS11
         INTEGER I,I1,J,J0,J1,K0,K0MAX,K1,K2,K3,K4,M
         REAL C,C0,C1,C2,C3,CA,CA0,CF,CF0,CP1,CR0,CR3,CR4,CZ,CZ0,D,F0,
     1        F1,F2,F3,H,H1,P0,P1,PJ,Q0,Q1,QJ,R0,R1,R10,R11,R12,R13,
     2        R14,R15,R16,R17,R18,R19,R2,R20,R21,R22,R23,R24,R25,R26,
     3        R27,R3,R4,R5,R6,R7,R8,R9,RC,RIC,RIS,RJ,RS,S1,S2,S3,SA,
     4        SA0,SF,SF0,SP1,SR0,SR3,SR4,SYS005,SYS035,SZ,SZ0,X,X0,X1,
     5        X2,X3,Z,Z0,Z1,Z2,ZZ
         LOGICAL MI
         DIMENSION C(8),X(8),Z0(52),Z1(13),Z2(13)
         DATA Z0(1)/.1E-10/,Z0(2)/-.366E-9/,Z0(3)/.10898E-7/,
     1        Z0(4)/-.267681E-6/,Z0(5)/.527608E-5/,Z0(6)
     2        /-.8105684E-4/,Z0(7)/.0009339901/,Z0(8)/-.007651298/,
     3        Z0(9)/.04114095/,Z0(10)/-.1271339/,Z0(11)/.1743608/,
     4        Z0(12)/-.08081119/,Z0(13)/.5479104/,Z0(14)/.4E-11/,
     5        Z0(15)/-.128E-9/,Z0(16)/.4206E-8/,Z0(17)/-.11507E-6/,
     6        Z0(18)/.2562196E-5/,Z0(19)/-.4532192E-4/,Z0(20)
     7        /.0006174202/,Z0(21)/-.006220184/,Z0(22)/.04386819/,
     8        Z0(23)/-.2007174/,Z0(24)/.5386666/,Z0(25)/-.7996168/,
     9        Z0(26)/1.053859/,Z0(27)/.1E-11/
         DATA Z0(28)/-.4E-11/,Z0(29)/.14E-10/,Z0(30)/-.54E-10/,
     1        Z0(31)/.239E-9/,Z0(32)/-.1176E-8/,Z0(33)/.6545E-8/,
     2        Z0(34)/-.42829E-7/,Z0(35)/.347441E-6/,Z0(36)
     3        /-.3810219E-5/,Z0(37)/.6627508E-4/,Z0(38)/-.002617530/,
     4        Z0(39)/.9945488/,Z0(40)/.2E-11/,Z0(41)/-.6E-11/,
     5        Z0(42)/.18E-10/,Z0(43)/-.72E-10/,Z0(44)/.298E-9/,
     6        Z0(45)/-.1346E-8/,Z0(46)/.6798E-8/,Z0(47)/-.39518E-7/,
     7        Z0(48)/.275996E-6/,Z0(49)/-.2475448E-5/,Z0(50)
     8        /.3202967E-4/,Z0(51)/-.0007552029/,Z0(52)/.06088192/,
     9        X(1)/.4947005/,X(2)/.4722875/,X(3)/.4328156/
         DATA X(4)/.3777022/,X(5)/.3089381/,X(6)/.2290084/,X(7)
     1        /.1408018/,X(8)/.04750625/,C(1)/.01357623/,C(2)
     2        /.03112676/,C(3)/.04757926/,C(4)/.06231449/,C(5)
     3        /.07479799/,C(6)/.08457826/,C(7)/.09130171/,C(8)
     4        /.09472531/,SYS005/1.570796/,SYS035/0.3989423/,
     5        K0MAX/524288/
       IERR = 0
       K = IABS(K)
       IF (K .EQ. 0) GO TO 240
          D = B - A
          IF (D .NE. 0.) GO TO 10
             RINT1 = 0.
             RINT2 = 0.
             GO TO 240
   10  CONTINUE
       K0 = K
       F0 = F(A)
   20  CONTINUE
       RINT1 = 0.
       RINT2 = 0.
       X3 = A
       F3 = F0
       J = 1
       IF (P .LT. 0.) J = -1
       PJ = P*J
       QJ = Q*J
       RJ = R*J
       H = D/K0
       H1 = .5*H
       P0 = PJ*H*H
       DO 200 I = 1, K0
          X1 = X3
          Q0 = ((PJ + PJ)*X1 + QJ)*H
          J0 = 1
          IF (Q0 .LT. 0.) J0 = -1
          Q1 = Q0*J0
          IF (P0 .LE. 1. .AND. Q1 .LE. 10.) GO TO 150
             P1 = P0 + Q0
             CP1 = COS(P1)
             SP1 = SIN(P1)
             R1 = P0 + P1
             IF (Q1 .GE. 10.*P0) GO TO 110
                J1 = 1
                IF (R1 .LT. 0.) J1 = -1
                R2 = 1./P0
                R3 = R2 + R2
                R4 = .25*R2*Q0
                R5 = R2*(.5 + R4 + R4)
                R6 = R2 + R5
                R7 = 1. + R6*Q0
                R8 = 4.*R2*R4
                R9 = R3 + R8
                R10 = R9*Q0
                R11 = R5 - R8
                R12 = R2 - R11
                R13 = 1. + R10 - R7
                R14 = SQRT(SYS005*R2)
                Z = R4*Q0
                CZ0 = COS(Z)
                SZ0 = SIN(Z)
                MI = Z .LT. 8.
                ASSIGN 30 TO M
                IF (MI) GO TO 50
                   CZ = CZ0
                   SZ = SZ0
                   GO TO 40
   30        CONTINUE
             CF0 = CF
             SF0 = SF
             Z = Z + P1
             MI = Z .LT. 8.
             ASSIGN 100 TO M
             IF (MI) GO TO 50
                CZ = CZ0*CP1 - SZ0*SP1
                SZ = CZ0*SP1 + SZ0*CP1
   40        CONTINUE
             R15 = 8./Z
             K1 = 26
             GO TO 60
   50     CONTINUE
          R15 = Z/8.
          K1 = 0
   60     CONTINUE
          K2 = K1 + 13
          R16 = 4.*R15*R15 - 2.
          Z1(1) = Z0(K1+1)
          Z1(2) = R16*Z1(1) + Z0(K1+2)
          Z2(1) = Z0(K2+1)
          Z2(2) = R16*Z2(1) + Z0(K2+2)
          DO 70 I1 = 3, 13
             K3 = K1 + I1
             K4 = K2 + I1
             Z1(I1) = R16*Z1(I1-1) - Z1(I1-2) + Z0(K3)
             Z2(I1) = R16*Z2(I1-1) - Z2(I1-2) + Z0(K4)
   70     CONTINUE
          R17 = SYS035*Z1(13)
          R18 = SYS035*Z2(13)*R15
          R19 = SQRT(Z)
          IF (MI) GO TO 80
             CF = .5 + (R17*SZ - R18*CZ)/R19
             SF = .5 - (R17*CZ + R18*SZ)/R19
             GO TO 90
   80     CONTINUE
          CF = R17*R19
          SF = R18*R19
   90     CONTINUE
          GO TO M,(30,100)
  100     CONTINUE
          CF0 = CF*J1 - CF0*J0
          SF0 = SF*J1 - SF0*J0
          R20 = R14*(CF0*CZ0 - SF0*SZ0)
          R21 = R14*(CF0*SZ0 + SF0*CZ0)
          C1 = R7*R20 - R2*R21 - R5*SP1
          S1 = R7*R21 + R2*R20 + R5*CP1 - R6
          C2 = R3*R21 - R10*R20 + R8*SP1
          S2 = R9 - R10*R21 - R3*R20 - R8*CP1
          C3 = R13*R20 - R2*R21 + R11*SP1
          S3 = R13*R21 + R2*R20 - R11*CP1 - R12
          GO TO 170
  110     CONTINUE
          R2 = 1./R1
          R3 = R2*R2
          R4 = R2*R3
          R5 = 1./Q0
          R6 = R5*R5
          R7 = R5*R6
          R8 = 4.*P0
          R9 = R8 + R8
          R10 = P0*R8 + (Q0 + Q0)*(P0 + R1)
          R11 = 4.*Q0*R1
          R12 = (Q0 + Q0)*P1
          Z = (P0 + P0)*R6
          ZZ = 3.*R6*R7
          ASSIGN 120 TO M
          GO TO 130
  120     CONTINUE
          CA0 = CA
          SA0 = SA
          Z = (P0 + P0)*R3
          ZZ = 3.*R3*R4
          ASSIGN 140 TO M
  130     CONTINUE
          R13 = 5.*ZZ*Z
          R14 = 7.*R13*Z
          R15 = 9.*R14*Z
          R16 = 11.*R15*Z
          R17 = 13.*R16*Z
          R18 = 15.*R17*Z
          R19 = 17.*R18*Z
          CA = ZZ - R14 + R16 - R18
          SA = R19 - R17 + R15 - R13
          GO TO M,(120,140)
  140     CONTINUE
          R20 = CA0 - CA*CP1 + SA*SP1
          R21 = SA0 - CA*SP1 - SA*CP1
          R22 = R3*CP1
          R23 = R3*SP1
          R24 = R4*CP1
          R25 = R4*SP1
          R26 = R8*R20
          R27 = R8*R21
          C1 = R26 + R10*R21 + R22 + 2.*(R25 + P0*R7) + 3.*R6
          S1 = R27 - R10*R20 + R23 - 2.*(R24 - R7) + R5
          C2 = -R9*R20 - R11*R21 - 4.*(R22 + R25 + R6)
          S2 = R11*R20 - R9*R21 + 4.*(R24 - R23 - R7)
          C3 = R26 + R12*R21 + 2.*(R22 + R25) + Q0*R24 + R2*SP1 + R6
          S3 = R27 - R12*R20 + 2.*(R23 - R24 + R7) + Q0*R25 - R2*CP1
          GO TO 170
  150     CONTINUE
          C1 = 0.
          S1 = 0.
          C2 = 0.
          S2 = 0.
          C3 = 0.
          S3 = 0.
          DO 160 I1 = 1, 8
             X0 = X(I1)
             R1 = .5 + X0
             R2 = .5 - X0
             R3 = (Q0 + P0*R1)*R1
             R4 = (Q0 + P0*R2)*R2
             CR3 = COS(R3)
             SR3 = SIN(R3)
             CR4 = COS(R4)
             SR4 = SIN(R4)
             R5 = R1*CR3
             R6 = R1*SR3
             R7 = R2*CR4
             R8 = R2*SR4
             R9 = R1 + R1 - 3.
             R10 = R2 + R2 - 3.
             C0 = C(I1)
             C1 = C1 + C0*(R9*R5 + CR3 + R10*R7 + CR4)
             S1 = S1 + C0*(R9*R6 + SR3 + R10*R8 + SR4)
             C2 = C2 - (C0 + C0)*((R9 + 1.)*R5 + (R10 + 1.)*R7)
             S2 = S2 - (C0 + C0)*((R9 + 1.)*R6 + (R10 + 1.)*R8)
             C3 = C3 + C0*((R9 + 2.)*R5 + (R10 + 2.)*R7)
             S3 = S3 + C0*((R9 + 2.)*R6 + (R10 + 2.)*R8)
  160     CONTINUE
  170     CONTINUE
          X2 = X1 + H1
          IF (I .LT. K0) GO TO 180
             X3 = B
             GO TO 190
  180     CONTINUE
          X3 = X2 + H1
  190     CONTINUE
          F1 = F3
          F2 = F(X2)
          F3 = F(X3)
          RC = C1*F1 + C2*F2 + C3*F3
          RS = S1*F1 + S2*F2 + S3*F3
          R0 = RJ + (QJ + PJ*X1)*X1
          CR0 = COS(R0)
          SR0 = SIN(R0)
          RINT1 = RINT1 + CR0*RS + SR0*RC
          RINT2 = RINT2 + CR0*RC - SR0*RS
  200  CONTINUE
       RINT1 = H*RINT1*J
       RINT2 = H*RINT2
       IF (E .LE. 0.) GO TO 230
          IF (K0 .NE. K) GO TO 220
  210     CONTINUE
          RIS = RINT1
          RIC = RINT2
          K0 = K0 + K0
          IF (K0 .LE. K0MAX) GO TO 20
             IERR = 65
             CALL UTQS11(IERR,13)
             K0 = K0/2
             GO TO 230
  220  CONTINUE
       R1 = L1*ABS(RINT1-RIS)
       R2 = L2*ABS(RINT2-RIC)
       IF (AMAX1(R1,R2) .GT. E) GO TO 210
  230  CONTINUE
       K = K0
  240  RETURN
      END
